<?php
//
// This migration adds the "All Sources" source group to the sql
//

class Migration_add_all_sources_sg extends CI_Migration {
    
    function up()
    {
    	// Load Pre-Reqs
        $this->load->library('Source', array('NOLOAD' => TRUE));
        $this->load->library('Sourcegroup', array('NOLOAD' => TRUE));

        // Grab all the Source Groups out of the DB
        $sg_list = array();
        $sql = "SELECT * FROM `nagiosna_SourceGroups`";
        $query = $this->db->query($sql);
        foreach ($query->result() as $row) {
            $sg_list[$row->name] = array();
            $s = "SELECT * FROM `nagiosna_SGLinker` WHERE `gid` = " . $row->gid;
            $q = $this->db->query($s);
            foreach ($q->result() as $r) {
                $sg_list[$row->name][] = $r->sid;
            }
        }

        // Truncate tables so we can rebuild them from scratch
        $trunc = "TRUNCATE TABLE `nagiosna_SGLinker`";
        $this->db->query($trunc);
        $trunc = "TRUNCATE TABLE `nagiosna_SourceGroups`";
        $this->db->query($trunc);

        // Insert the new "All Sources" Source Group
        $index = 1;
        $sql = "INSERT INTO `nagiosna_SourceGroups` (`gid`, `name`) VALUES (".$index.", 'All Sources')";
        $this->db->query($sql);

        // Add the old Source Groups back into the DB
        foreach ($sg_list as $sg_name => $link_list) {
            $index++;
            $sql = "INSERT INTO `nagiosna_SourceGroups` (`gid`, `name`) VALUES (".$index.", '".$sg_name."')";
            $this->db->query($sql);
            foreach ($link_list as $sid) {
                $sql = "INSERT INTO `nagiosna_SGLinker` (`gid`, `sid`) VALUES (".$index.", ".$sid.")";
                $this->db->query($sql);
            }
        }

        // Add all sources to the new "All Sources" Source Group
        $sources = Source::enumerate();
        $sg = new Sourcegroup(1);
        foreach ($sources as $source) {
            $sg->add_source_associations($source['sid']);
        }
    }
    
    function down()
    {
    	// There is no down
    }
}

?>
